function eeg = set_selepos(eeg, epos)
% Out-Set = set_selepos(In-Set, Epoch-Indices)
% select a subset of epochs from a dataset
%
% In:
%   In-Set        : epoched EEGLAB data set from which epochs shall be selected
%
%   Epoch-Indices : indices of the epochs that should be retained
% 
% Out:
%   Out-Set : newly created dataset that contains only the selected epochs.
%
%                               Christian Kothe, Swartz Center for Computational Neuroscience, UCSD
%                               2010-04-01

if ~exp_begindef('editing') return; end

eeg = pop_select(eeg,'trial',epos,'sort',0);

exp_enddef;
