function eeg = set_selinterval(eeg,domain,interval)
% Out-Set = set_selinterval(In-Set,Interval)
% Selects a time interval from a an EEG Set;
%
% In:
%   In-Set   :   continuous EEGLAB dataset from which an interval should be selected
%
%   Domain   :   either 'time' (then the interval is in seconds) 
%                or 'points' (then the interval is in points a.k.a. samples)
%
%   Interval :   selection interval, [start end; start end; start end; ...]
%
% Out:
%   Out-Set  :   dataset restricted to the selected range
%
%                           Christian Kothe, Swartz Center for Computational Neuroscience, UCSD
%                           2010-04-01

if ~exp_begindef('editing') return; end

eeg = pop_select(eeg,domain,interval,'sort',0);

exp_enddef;
