function res = exp_block(assignments, expr) 
% Result = exp_block(Assignments, Expression)
% define a block with dynamically scoped values for symbols used in the contained expression.
%
% In:
%   Assignments : cell array of exp_set/exp_setdelayed/exp_rule expressions; the left-hand side (first argument) of the assignment expressions is 
%                 replaced by the respective right-hand side (second argument) in the scope of the block expression; this implements dynamically scoped variables.
%
%   Expression  : an expression to be evaluated with assignments as listed in the block
%
% Out:
%   Result : a block expression
%
%                                        Christian Kothe, Swartz Center for Computational Neuroscience, UCSD
%                                        2010-05-03


if ~exp_begindef('symbolic') return; end

res = utl_block(assignments,expr,exp_internal_context.exec_ctx);

exp_enddef;
