function [eq,dict] = exp_match(exp,form,dict)
% [Equals,Assignment] = exp_match(Expression, Pattern)
% Check whether an expression is matched by a pattern; The pattern may contain blanks and named sub-patterns.
% Assignment is an optional output which contains sub-expressions matched by named parts of the pattern.
%
%                                       Christian Kothe, Swartz Center for Computational Neuroscience, UCSD
%                                       2010-04-19

if ~exp_begindef('symbolic') return; end

if ~exist('dict','var')
    dict = struct(); end

[eq,dict] = utl_match(exp,form,dict);

exp_enddef;