function exp = exp_releasehold(exp)
% [Out-Expression] = exp_releasehold(In-Expression)
% peels off hold expressions from In-Expressions (only the first level of holds is peeled off)
%
% In:
%   In-Expression      : some expression
%
% Out:
%   Out-Expression     : In-Expression with the first level of Hold's peeled off
%
% Notes:
%   Descends into cell arrays.
%
%                                       Christian Kothe, Swartz Center for Computational Neuroscience, UCSD
%                                       2010-05-19

if ~exp_begindef('symbolic') return; end

exp = utl_releasehold(exp);

exp_enddef;