function info = utl_blinkdb(argument)
% store/load the given blink information (taken from utl_calcblink) to disk, for use with flt_deblink
% utl_blinkdb(blinkinfo) -> store the given blink info
% blinkinfo = utl_blinkdb(chanlocs) -> load the blink info associated with
% the given chanlocs
%
%
%                               Christian Kothe, FG MMS, TU-Berlin
%                               25.10.2007


global blinkdb

% first make sure that the blink pattern database is loaded
if isempty(blinkdb)    
    try load sto_blinkdb; catch, end;
end

if isfield(argument,'chanlocs')
    % we have a blink info -> store it    
    blinkdb.(['x' num2str(hlp_stringhash(utl_manglename('blinkinfo',argument.chanlocs)))]) = argument;
    save sto_blinkdb blinkdb;
    disp('Updated sto_blinkdb.');
elseif isfield(argument,'labels')
    % we have channel locations -> load the associated blink info
    try
        info = blinkdb.(['x' num2str(hlp_stringhash(utl_manglename('blinkinfo',argument)))]);
    catch
        error('No blinkinfo available for the given channel locations');
    end
else
    error('Invalid argument: Please specify either channel locations or a blinkinfo structure');
end
