function vis_discriminability(input,set_info,wnds,dims)
% vis_discriminability(Set,{},Windows)
% display the cortical discriminability (by a QDA classifier) over some given windows
% In:
%       Set     : the preprocessed, epoched eeg set to be analyzed
%       Windows : the time windows to be analyszed (for each window, a new subplot is generated)
%
% Examples:
%   vis_discrimiability(myset,{},[0.3 0.4;0.4 0.5]);
%
% Notes:
%   this is the spatial complement to vis_erp (which acts in the time domain), except that it shows
%   only (undirected) discriminability
%
%                               Christian Kothe, FG MMS, TU-Berlin
%                               05.06.2007


d = utl_discriminability(input,set_info,[],wnds);
if ~exist('dims') dims = [1 size(d,2)]; end

for i=1:size(d,2)
%    subplot(1,size(d,2),i);
    subplot(dims(1),dims(2),i);    
    topoplot(d(:,i),input.chanlocs,'maplimits',[0 1]);
    title([num2str(i) ': [' num2str(wnds(i,1)) '-' num2str(wnds(i,2)) ']']);
end