function vis_patterns(cla,chanlocs,doabs,varargin)
% vis_patterns(Classifier/Patterns(,Set/Chanlocs))
% display the CSP projections from a classifier
%
% Examples:
%   vis_patterns(cla)
%
%
%                               Christian Kothe, FG MMS, TU-Berlin
%                               02.04.2007

if ~exist('doabs') doabs = 0; end

if isstruct(cla) 
    if doabs 
        patterns = abs(cla.csp.patterns);
    else
        patterns = cla.csp.patterns;
    end
    if ~exist('chanlocs') & isfield(cla,'chanlocs') || isempty(chanlocs) chanlocs = cla.chanlocs; end
else
    if doabs
        patterns = abs(cla);
    else
        patterns = cla;
    end
end

if isfield(chanlocs,'chanlocs') chanlocs = chanlocs.chanlocs; end

nof = size(patterns,1);
if mod(nof,2) == 1
    % uneven number of patterns
    for i=1:nof
        subplot(1,nof,i);
        topoplot(patterns(i,:),chanlocs,varargin{:});
        title(i);
       % colorbar;
    end
else
    % even number of patterns
    nof = nof/2;
    % for each pattern pair
    for i=1:nof
        subplot(2,nof,i);
        topoplot(patterns(i,:),chanlocs,varargin{:});
        title(i);
        subplot(2,nof,nof+i);
        topoplot(patterns(nof*2-i+1,:),chanlocs,varargin{:});
        title(nof*2-i+1);   
        
    %   colorbar;
    end
end