function vis_speccsp = vis_speccsp(cla)
% function that gets the classifier and plot the patterns and frequency bands
% for the dimensions specified
% author: matti gaertner, mga@mms.tu-berlin.de

% Examples:
%   vis_speccsp(cla)


nof = size(cla.csp.patterns,1);
range  = cla.csp.freqs >= 7 & cla.csp.freqs <= 30;
mx = max(max(cla.csp.flt));

% TODO: uneven number of patterns
% if mod(nof,2) == 1

% do the plotting
for i = 1:nof/2
    figure;
    subplot(2,2,1)
    topoplot(cla.csp.patterns(i,:), cla.chanlocs);
    colorbar;
    subplot(2,2,3)
    topoplot(cla.csp.patterns(nof-i+1,:), cla.chanlocs);
    colorbar;
    subplot(2,2,2)
    plot(cla.csp.freqs(range), cla.csp.flt(i,range));
    axis square;
    ylim([0 mx]*1.1)
    title(['\bfpatterns and band no. ' num2str(i)])
    xlabel('frequencies in Hz');
    subplot(2,2,4)
    plot(cla.csp.freqs(range), cla.csp.flt(nof-i+1,range));
    axis square;
    ylim([0 mx]*1.1)
    title(['\bfpatterns and band no. ' num2str(nof-i+1)])
    xlabel('frequencies in Hz');
    %text(0.2, 0.2, ['model: ' cla.model.args 'w for class 1 / 2: ' num2str(cla.model.w(i)) ' / ' num2str(cla.model.w(nof-i+1))'])
end

% if mod(nof,2) == 1
%     % uneven number of patterns
%     for i=1:nof
%         subplot(1,nof,i);
%         topoplot(patterns(i,:),chanlocs);
%         title(i);
%        % colorbar;
%     end
% else
%     % even number of patterns
%     nof = nof/2;
%     % for each pattern pair
%     for i=1:nof
%         subplot(2,nof,i);
%         topoplot(patterns(i,:),chanlocs);
%         title(i);
%         subplot(2,nof,nof+i);
%         topoplot(patterns(nof*2-i+1,:),chanlocs);
%         title(nof*2-i+1);   
%         
%     %   colorbar;
%     end
% end