											  //---------------------------------------------------------------------------

#ifndef DataArrayMatlabH
#define DataArrayMatlabH
//---------------------------------------------------------------------------
//=====================================================


#ifdef MYDLL_EXPORTS
#define MYDLL_API __declspec(dllexport)
#else
#define MYDLL_API __declspec(dllimport)
#endif


#ifdef __cplusplus
extern "C"
{
#endif

#define MAXITEMS (337+3)    // 340: max aggregate channels (DataRiver)
struct TDArray
{
	long nMaxItems;
	long nItems;
	long ItemSize;
	long TimeStampOrig;
	long TimeStampDest;
	long TimeCorrection;
	long UserData[2+8]; // 44 bytes
	long MaskIs24[16]; // 16 * 32 = 512 bits (max.ch)
	long Data[MAXITEMS];
};


// some data types defined, define your own or use those below:




//---------------------- Reading from buffer ---------
MYDLL_API void * ds_OpenAsyncRead(char * mmfId);
MYDLL_API void  ds_CloseAsyncRead(void * handle); //identical to ReleaseThread

// PopData CAN BE USED FOR BOTH SYNC AND ASYNC READS
MYDLL_API DWORD ds_PopData(void * h,TDArray * buf);  // return size and data in *buf, 0 if empty

//--------------------- Writing to buffer --------------
//MYDLL_API void * ds_InitDataBuffer(char * name);
//MYDLL_API void ds_ReleaseDataBuffer(void * handle);
//MYDLL_API void ds_PushData(void * h,TDArray * data, int size);

MYDLL_API void * ds_OpenWrite(char * name);
MYDLL_API void ds_CloseWrite(void * handle);
MYDLL_API void ds_Write(void * h,TDArray * data, int size);
//--------------------- Writing event code --------------
MYDLL_API void * ds_OpenEvCodeWrite();
MYDLL_API void ds_CloseEvCodeWrite(void * handle);
//MYDLL_API void ds_PushCode(void * h,int code);
MYDLL_API void ds_WriteEvCode(void * h,int code);

//------------------ util
MYDLL_API unsigned long ds_TSMillisecs();
MYDLL_API void ds_NewMaxArray(TDArray * ma);


#ifdef __cplusplus
}
#endif

#endif


