// #ifndef DataArrayMatlabH
// #define DataArrayMatlabH
// 
// 
// #ifdef __cplusplus
// extern "C"
// {
// #endif
// 
// #define MAXITEMS (641)    // max aggregate channels (DataRiver)
struct TDArray
{
	long nMaxItems;
	long nItems;
	long ItemSize;
	long TimeStampOrig;
	long TimeStampDest;
	long TimeCorrection;
	long UserData[6];  // 
	long MaskIs24[20]; // 20 * 32 = 640 bits (max.ch)
	long Data[641];
	long Reserved;
};


//---------------------- Reading from buffer ---------
//  
 	unsigned long  ds_OpenRead   (char * mmfId);
 	unsigned long ds_WrHandle   (unsigned long hr);
	
    unsigned int  ds_Peek	     (unsigned long hr, void * buf);       // return size(in bytes) and data in *buf, 0 if empty, does not move tail
	unsigned int  ds_PeekPtr    (unsigned long  hr, void * * bufaddr); // return size(in bytes) and data adddress in *bufaddr, 0 if empty, does not move tail
	unsigned int  ds_Read       (unsigned long  hr, void * buf);       // return size(in bytes) and data in *buf, 0 if empty
	unsigned int  ds_ReadPtr    (unsigned long  hr, void * * bufaddr); // return size(in bytes) and data adddress in *bufaddr, 0 if empty
	void   ds_CloseRead  (unsigned long  hr);
	int    ds_TailIs     (unsigned long  hr);
	void   ds_ResetTail  (unsigned long  hr);
	unsigned int ds_NodesToRead(unsigned long  hr);
	unsigned int ds_TailPos    (unsigned long  hr);
	unsigned int ds_HeadPos    (unsigned long  hr);


//---------------------- Writing to buffer -----------------------
	unsigned long  ds_OpenWrite  (char * name, int nodesize,int freq);
	void   ds_CloseWrite (unsigned long  hw);
	unsigned int ds_Write      (unsigned long  h,void *  data, int size); // returns head position


//-------------------- Utility func.  ----------------------------

	char * ds_GetParamPtr(unsigned long  hw); //typecast to TADParams *. NOTE: use handle returned by ds_OpenWrite or ds_HandleIs(hr)!
	int    ds_TimestampMs(void);

// 
// #ifdef __cplusplus
// }
// #endif
// 
// #endif
// 
// 
