path = fileparts(mfilename('fullpath'));

% find out if we need to rebuild any of these files
need_rebuild = false;
rebuild_files = {'Scheduler.class','Scheduler$1.class','Scheduler$ResultHandler.class','Scheduler$ResultReceiver.class','Scheduler$WorkerLink.class','ChunkReader.class'};
for i=1:length(rebuild_files)
    if ~exist([path filesep rebuild_files{i}],'file') 
        need_rebuild = true;
        break;
    end
end

if need_rebuild
    % try to rebuild them (note: assumes a certain matlabcontrol version)
    cd(path);
    disp('Building ChunkReader.java...');
    if system('javac ChunkReader.java')
        error('BCILAB:SchedulingBuildError',['failed to build the ChunkReader.java file; distributed computing will only work if the Parallel Computing Toolbox is set up.\n' ...
              'You can try to manually build this file with the Java distribution shipped with MATLAB.']);
    end
    disp('Building Scheduler.java...');
    if system('javac -classpath ../matlabcontrol-3.10/matlabcontrol-3.1.0.jar Scheduler.java')
        error('BCILAB:SchedulingBuildError',['failed to build the Scheduler.java file; distributed computing will only work if the Parallel Computing Toolbox is set up.\n' ...
              'You can try to manually build this file with the Java distribution shipped with MATLAB.\n' ...
              'Also check whether the matlabcontrol-*.** version matches that in this file (' mfilename('fullpath') ')']); 
    end
end

% add to the path
javaaddpath(fileparts(mfilename('fullpath')))
