function combinedTemplateActivation = accumulate_ic_spectral_decomposition_activations(icSpectralDecomposition)

numberOfSpectralTemplatesPerIc = size(icSpectralDecomposition(1).activation,1);
combinedTemplateActivation = zeros(length(icSpectralDecomposition) * numberOfSpectralTemplatesPerIc, size(icSpectralDecomposition(1).activation,2) - length(unique(icSpectralDecomposition(1).badFrames)), size(icSpectralDecomposition(1).activation,3));

% accumulating activation of all ic septral decompositions
for i=1:length(icSpectralDecomposition)
    cleanActivityI = icSpectralDecomposition(i).activation;
    
    if ~isempty(icSpectralDecomposition(i).badFrames)
        cleanActivityI(:,icSpectralDecomposition(i).badFrames,:) = [];
    end;
    
    combinedTemplateActivation(1+ ((i-1) * numberOfSpectralTemplatesPerIc):(i*numberOfSpectralTemplatesPerIc),:,:) = cleanActivityI;
end;

