function old__plot_independent_modulator_ic_decompositions(imNumber, icSpectralDecomposition, mix, numberOfTemplatesOrIcsToPlot)
% plot_independent_modulator(imNumber, icSpectralDecomposition, mix, numberOfTemplatesOrIcsToPlot)

numberOfTemplatesPerIc = icSpectralDecomposition(1).numberOfSpctralTemplates;

templateWeights = mix(:,imNumber);

[sortedTemplateWeight sortedTemplateNumber] = sort(templateWeights,'descend');

templateIcId = ceil(sortedTemplateNumber / numberOfTemplatesPerIc);
templateIdInIc = sortedTemplateNumber - (templateIcId-1) * numberOfTemplatesPerIc;

%plot(sort(abs(mix(:,1)),'descend'),'o-');

icIds = templateIcId(1:numberOfTemplatesOrIcsToPlot);
modeIds = templateIdInIc(1:numberOfTemplatesOrIcsToPlot);
polarities = sign(sortedTemplateWeight(1:numberOfTemplatesOrIcsToPlot));


%% plotting
figure;
numberOfRows = 2;
numberOfColumns = ceil(length(icIds) / 2);

for i=1:numberOfTemplatesOrIcsToPlot
    
    modeAxis = sbplot(numberOfRows,numberOfColumns,i, 'visible','off');
    
    sbplot(4,1,1, 'ax', modeAxis, 'visible','off');
    topoplot(icSpectralDecomposition(icIds(i)).scalpMap, icSpectralDecomposition(icIds(i)).chanlocs,'plotrad',0.5);
    
    sbplot(4,1,[2 3], 'ax', modeAxis);
    plot_single_spectral_template(icSpectralDecomposition(icIds(i)),modeIds(i), polarities(i));
    title(['IC=' num2str(icSpectralDecomposition(icIds(i)).comp) ', mode=' num2str(modeIds(i)), ', polarity=' num2str(polarities(i))]);
end;
