function plot_spectral_template(icSpectralDecomposition, templateNumber)
% if no or more than one elements in templateNumber are given, they (all templates as default) will be plotted in a multiple axis in a grid
% otherwise just one template will be ploted in the current axis.

% if zero or more than one template number is given, show all of them 

if nargin<2 || isempty(templateNumber)
     templateNumber = 1:icSpectralDecomposition.numberOfSpctralTemplates;
end;

numberOfRows = ceil(length(templateNumber) ^ 0.5);
numberOfColumns = numberOfRows;

if nargin<2 || length(templateNumber)>1
    figure;
    sbplot(numberOfRows, numberOfColumns, 1);
    topoplot(icSpectralDecomposition.scalpMap, icSpectralDecomposition.chanlocs);
    
    title(['Comp.' num2str(icSpectralDecomposition.comp)]);
    for i=1:icSpectralDecomposition.numberOfSpctralTemplates
        sbplot(numberOfRows, numberOfColumns, i+1);
        plot_single_spectral_template(icSpectralDecomposition, i,1);
    end;
else
    % plot a single template in the current axis
   plot_single_spectral_template(icSpectralDecomposition, templateNumber,1); 
end;

end
