
%% the old FFT window code

comps = [EEG.gdcomps EEG.muscle];
%comps = 2;%

%clear cSpectralDecomposition;
for compId = 16:length(comps)
    comp = comps(compId);
    data = EEG.icaact(comp,:);
    windowSizeinSeconds = 2;
    windowSizeinFrames = windowSizeinSeconds * EEG.srate;
    windowOverlapRatio = 0.75;
    numberOfLogSpacedFrequencies = 30;
    
    
    
    % initialize the array that hold window spectrums
    compWindowSpectrum = zeros(numberOfLogSpacedFrequencies, length(data) / (windowSizeinFrames * windowOverlapRatio));
    
    startFrame = 1;
    numberOfWindow = 0;
    while startFrame<(length(data)-windowSizeinFrames-1)
        
        windowData = data(startFrame:(startFrame + windowSizeinFrames - 1));
        
        NFFT = 2^nextpow2(windowSizeinFrames); % Next power of 2 from length of y
        Y = fft(windowData ,NFFT)/windowSizeinFrames;
        
        frequencies = EEG.srate/2*linspace(0,1,NFFT/2+1);
        frequencyAmplitude = 2*abs(Y(1:NFFT/2+1));
        
        % cut out first and last points since they are artifacts
        frequencies = frequencies(2:end-1);
        frequencyAmplitude = frequencyAmplitude(2:end-1);
        
        logSpacedFrequencies = logspace(log10(frequencies(1)), log10(frequencies(end)), numberOfLogSpacedFrequencies);
        % find frequency IDs closest to log-spaced frequencies
        for i=1:numberOfLogSpacedFrequencies
            [dummy logSpacedFrequencyId(i)] = min(abs(frequencies - logSpacedFrequencies(i)));
        end;
        
        % some frequency ids in logSpacedFrequencyId are repeated so we have to calculate the uniqe ones
        logSpacedFrequencyId = unique(logSpacedFrequencyId);
        
        % subsample frequencies to log-spaced
        frequencies = frequencies(logSpacedFrequencyId);
        frequencyAmplitude = frequencyAmplitude(logSpacedFrequencyId);
        
        startFrame = round(startFrame + windowOverlapRatio * windowSizeinFrames);
        numberOfWindow = numberOfWindow + 1;
        compWindowSpectrum(1:length(frequencyAmplitude), numberOfWindow) = frequencyAmplitude;
    end;
    
    % remove parts of the matrix that are not filled by calculated values
    compWindowSpectrum = compWindowSpectrum(1:length(frequencyAmplitude), 1:numberOfWindow);
    
    %figure;
    %plot(frequencies, mean(compWindowSpectrum, 2));
    
    
    % find how much of energy is be preserved
    % [coefs,scores,variances,t2] = princomp(compWindowDb');
    % percentVariance = 100*variances/sum(variances);
    % percentExplained =  sum(percentVariance(1:numberOfSpctralTemplates));
    % fprintf('%d percent of data is explained by %d selected pca dimensions.\n', round(percentExplained), numberOfSpctralTemplates);
    
    
    
    compMeanSpectrum = mean(compWindowSpectrum, 2);
    compWindowDb = log(compWindowSpectrum ./ repmat(compMeanSpectrum, 1, size(compWindowSpectrum, 2))) / log(10);
    
    numberOfSpctralTemplates = 10;
    
    [wts sph] = binica(compWindowDb, 'extended', numberOfSpctralTemplates, 'stop' ,1.0e-7,'maxsteps',1000, 'pca', numberOfSpctralTemplates);
    
    icSpectralDecomposition(compId).unmix = wts * sph;
    icSpectralDecomposition(compId).mix = pinv(wts * sph);
    icSpectralDecomposition(compId).meanPower = compMeanSpectrum;
    icSpectralDecomposition(compId).activation = ( wts * sph) * compWindowDb;
    icSpectralDecomposition(compId).comp = comp;
    icSpectralDecomposition(compId).numberOfFrequencies = length(frequencies);
    icSpectralDecomposition(compId).frequencies = frequencies;
    icSpectralDecomposition(compId).scalpMap = EEG.icawinv(:,comp);
    icSpectralDecomposition(compId).chanlocs = EEG.chanlocs;
    icSpectralDecomposition(compId).badFrames = [];
end;
    %save compWindowSpectrum
   %% 
    winv = pinv(wts * sph);
   % winv = icSpectralDecomposition(1).mix;
    figure;
    sbplot(5,5, 1);
    topoplot(EEG.icawinv(:,comp), EEG.chanlocs);
    title(['Comp.' num2str(comp)]);
    for i=1:numberOfSpctralTemplates
        sbplot(5,5, i+1);
        plot(frequencies, winv(:,i));
        hold on;
        %   plot(frequencies, winv(:,i),'o');
        set(gca, 'xtick',[2 5 10 25 100]);
        set(gca, 'xscale','log');
        xlabel('Freq. (Hz)');
    end;
    
    % saveas(gcf, ['/home/nima/test/spec_ica_mcbd_pb01_comp' num2str(comp) '_log.png']);
%end;
%% calculate spectral ica using continous

comp = 17;
frequencies = logspace(log10(3), log10(100), 25);

[wavelet,cycles,freqresol,timeresol] = dftfilt3( frequencies, 3, EEG.srate);

powerForWavelet = power_for_wavelet(ALLEEG(2), comp, wavelet);

meanPower = mean(powerForWavelet,2);

logPowerModulation = log(powerForWavelet ./ repmat(meanPower, 1, size(powerForWavelet, 2))) / log(10) ;


badIds = find(isnan(logPowerModulation) |isinf(logPowerModulation)  | logPowerModulation ==0);
[i j] = ind2sub( size(logPowerModulation), badIds);
cleanedModulation = logPowerModulation;
cleanedModulation(:,j) = [];

[wts sph] = binica(cleanedModulation, 'extended', numberOfSpctralTemplates, 'stop' ,1.0e-7,'maxsteps',1000, 'pca', numberOfSpctralTemplates);

imActivity = wts *sph * logPowerModulation;


%% im activity for epochs

powerForWaveletEpochs = power_for_wavelet(ALLEEG(4), comp, wavelet);
logPowerModulationEpochs = [];
imActivityEpochs  =[];
for epoch =1:size(powerForWaveletEpochs, 3)
    logPowerModulationEpochs(:,:,epoch) = log(squeeze(powerForWaveletEpochs(:,:,epoch)) ./ repmat(meanPower, 1, size(powerForWaveletEpochs, 2))) / log(10) ;
    imActivityEpochs(:,:,epoch) = wts *sph * squeeze(logPowerModulationEpochs(:,:,epoch));
end;

imActivityEpochs(find(isnan(imActivityEpochs) | isinf(imActivityEpochs))) = 0;


%%

figure;

im = 10;

plot(mean(nontargetImActivityEpochs(im,143:(end-143),:),3));
hold on;
plot(mean(targetImActivityEpochs(im,143:(end-143),:),3),'r');

%%
comps = [17 25 5 6 7 8 9 11 12 13 15 16 17 18 19 21 22 27];
%comps = comps(1:3);
clear icSpectralDecomposition imActivityEpochs logPowerModulationEpochs powerForWavelet powerForWaveletEpochs
for compId = 1:length(comps)
    compId
    icSpectralDecomposition(compId) = make_spectral_decomposition(ALLEEG(1), comps(compId), 10);
end;

save icSpectralDecomposition_many_exp53.mat icSpectralDecomposition;
%% calculate spectal templte activity correlation and show in a figure


combinedTemplateActivation = [];
for i=1:length(icSpectralDecomposition)
    cleanActivityI = icSpectralDecomposition(i).activity;
    cleanActivityI(:,icSpectralDecomposition(i).badFrames) = [];
    combinedTemplateActivation = cat(1, combinedTemplateActivation, cleanActivityI);
end;

 % remove the mean before third-level ica
for i=1:size(combinedTemplateActivation, 1)
    meanTemplateActivation(i) = mean(combinedTemplateActivation(i,:));
    combinedTemplateActivation(i,:) = combinedTemplateActivation(i,:) - meanTemplateActivation(i);
end;

combinedTemplateActivationCorrelation = corrcoef(combinedTemplateActivation');

combinedTemplateActivationCorrelation = combinedTemplateActivationCorrelation -diag(diag(combinedTemplateActivationCorrelation));


figure;
imagesc((combinedTemplateActivationCorrelation));
title('Correlation between activity of spectral modes of cortical ICs','fontsize',16);

set(gca,'xtick', [1 5 10 15 20 25 30]);
set(gca,'ytick', [1 5 10 15 20 25 30]);

set(gca,'xticklabel',['IC 17, mode 1 '; 'IC 17, mode 5 ';'IC 17, mode 10'; 'IC 25, mode 5 '; 'IC 25, mode 10'; 'IC  5, mode 5 '; 'IC  5, mode 10']);
set(gca,'yticklabel',['IC 17, mode 1 '; 'IC 17, mode 5 ';'IC 17, mode 10'; 'IC 25, mode 5 '; 'IC 25, mode 10'; 'IC  5, mode 5 '; 'IC  5, mode 10']);

set(gca,'fontsize',7);

%% cluster spctral templates based on their activity correlation

numberOfClusters = 6;

[examplarIdx,netsim,dpsim,expref]=apclusterK(abs(combinedTemplateActivationCorrelation), numberOfClusters, 5);

examplar = unique(examplarIdx);

IDX = zeros(1,length(examplar));
for i=1:length(examplar)
    comps = find(examplarIdx == examplar(i));
    clusterCorrelation{i} = abs(combinedTemplateActivationCorrelation(comps, comps));
    meanClusterCorrelation(i) = mean(clusterCorrelation{i}(:));
    IDX(comps) = i;
end;


%%

figure;

% icIds = [1 2 3];
% modeIds = [1 1 1];
% polarities = [1 -1 1];

%  icIds = [1 2 3];
%  modeIds = [3 4 3];
%  polarities = [1 -1 1];

% icIds = [1 3];
% modeIds = [2 2];
% polarities = [1 1];


%  icIds = [1 2 3];
%  modeIds = [8 8 8];
%  polarities = [1 -1 -1];

icIds = [1 2 3];
modeIds = [6 2 7];
polarities = [1 1 1];

modeNumberInCombined = (icIds-1) * 10 + modeIds;
combinedTemplateActivationCorrelation(modeNumberInCombined,modeNumberInCombined)

figure;
numberOfRows = 2;
numberOfColumns = ceil(length(icIds) / 2);

for i=1:length(icIds)
    
    modeAxis = sbplot(numberOfRows,numberOfColumns,i, 'visible','off');
    
    sbplot(4,1,1, 'ax', modeAxis, 'visible','off');
    topoplot(icSpectralDecomposition(icIds(i)).scalpMap, icSpectralDecomposition(icIds(i)).chanlocs,'plotrad',0.5);
    
    sbplot(4,1,[2 3], 'ax', modeAxis);
    plot_single_spectral_template(icSpectralDecomposition(icIds(i)),modeIds(i), polarities(i));
    title(['IC=' num2str(comps(icIds(i))) ', mode=' num2str(modeIds(i)), ', polarity=' num2str(polarities(i))]);
end;


%% third-level ica on template activatins

[wts3 sph3] = binica(combinedTemplateActivation, 'extended', 50, 'stop' ,1.0e-7,'maxsteps',1000, 'pca', 50);
save third_level_ica_mean_removed_exp53.mat wts3 sph3;
%%
imNumber = 5;
mix3 = pinv(wts3*sph3);
templateWeights = mix3(:,imNumber);


numberOfIcs = length(templateWeights) / numberOfTemplatesPerIc;
for icId=1:numberOfIcs
    icTemplateId = (1+(icId-1) * 10) : ((icId*10));
    icTemplateWeights(icId,:) = templateWeights(icTemplateId)' * icSpectralDecomposition(icId).mix';
    icTemplateRms(icId) = norm(templateWeights(icTemplateId),'fro');
end;

% plot im for top ics

[sortedIcImRms sortedIcId] = sort(icTemplateRms,'descend');


figure; plot(sortedIcImRms,'o-');
%% plot IM for IC
numberOfIcsToPlot = 10;

figure;
numberOfRows = 2;
numberOfColumns = ceil(numberOfIcsToPlot / 2);

% remove repeated comp 17 (ids 1 and 13 are both comp 17)
if any(sortedIcId == 1)
    sortedIcId(sortedIcId == 13) = [];
end;

for icIdId = 1:numberOfIcsToPlot
    icId = sortedIcId(icIdId);
    modeAxis = sbplot(numberOfRows,numberOfColumns,icIdId, 'visible','off');
    
    sbplot(4,1,1, 'ax', modeAxis, 'visible','off');
    topoplot(icSpectralDecomposition(icId).scalpMap, icSpectralDecomposition(icId).chanlocs,'plotrad',0.5);
    
    sbplot(4,1,[2 3], 'ax', modeAxis);
    
    plot(icSpectralDecomposition(icId).frequencies, icTemplateWeights(icId,:), 'linewidth',3);
    hold on;
    plot(icSpectralDecomposition(icId).frequencies, icTemplateWeights(icId,:),'.k');
    
    set(gca,'ygrid','on');
    
    set(gca, 'xtick',[min(icSpectralDecomposition(icId).frequencies) 5 7 10 17 25 50 100]);
    xlim([min(icSpectralDecomposition(icId).frequencies) max(icSpectralDecomposition(icId).frequencies)]);
    set(gca, 'xscale','log');
    xlabel('Freq. (Hz)');
end;

%%

combinedFullTemplateActivation = [];
for i=1:length(icSpectralDecomposition)
    combinedFullTemplateActivation = cat(1, combinedFullTemplateActivation,  icSpectralDecomposition(i).activity - meanTemplateActivation(i));
end;

imActivation = wts3 * sph3 * combinedFullTemplateActivation;

%%
imNumber = 1; %7 8 9 4
datasetNumber = 6;
[epochedInputArray meanInputArray] = epoch_on_demand(ALLEEG(datasetNumber), imActivation(imNumber,:));

for i=1:size(epochedInputArray, 1)
    epochedInputArray(i,:) = smooth(epochedInputArray(i,:),3);
end;

times= linspace(ALLEEG(datasetNumber).xmin*1000, ALLEEG(datasetNumber).xmax*1000, length(meanInputArray));

figure; 
imagesc(times,1:size(epochedInputArray,2) ,epochedInputArray');
caxis([-quantile(-epochedInputArray(:),0.95) quantile(epochedInputArray(:),0.95)]);
title(['IM ' num2str(imNumber)]);


figure; plot(times, meanInputArray);
title(['IM ' num2str(imNumber)]);

%%
