% load raw dataset (but resampled to 200 Hz, for speed)
raw = flt_resample(io_loadset('data:/christian/Demo/imag.vhdr'), [], 200);
markers = {'S  1','S  2'};   % these are our class-indicating stimulus markers

% train a model and obtain a default (cross-validated) performance estimate (here: mis-classification rate)
[trainmeasure,model,x,trainstatistics] = bci_train({'data',raw,'func',@para_csp},'events',markers);
%[trainmeasure,model,x,trainstatistics] = bci_train({'data',raw,'func',@para_csp,'eval_scheme',{'chron',20,5}},'events',markers,'window',[-0.5 2.5]);
%[trainmeasure,model,x,trainstatistics] = bci_train({'data',raw,'func',@para_csp},'events',markers,'learner',{'svmlinear'});
disp(['training mis-classification rate: ' num2str(trainmeasure*100,3) '%']);

% % apply the model to the same raw dataset (pretending that this is some valid test session, which it isn't)
% [prediction,testmeasure,teststatistics,targets] = bci_predict(model,raw);
% disp(['predicted classes: ',num2str(round(prediction{2}*prediction{3})')]);  % class probabilities * class values
% disp(['true classes     : ',num2str(round(targets)')]);

% % ... also, for demo purposes, stream the raw dataset through the online system (predicting 3.5 seconds after each marker)
% [online_predictions,online_latencies] = onl_stream(raw,model,'markers',markers, 'offset',3.5*200);
% disp(['online prediction; ',num2str(round(online_predictions{2}*online_predictions{3})')]);




% real quick online streaming test
% [trainmeasure,model,x,trainstatistics] = bci_train({'data',raw,'func',@para_csp,'eval_scheme',0},'events',markers);
% [online_predictions,online_latencies] = onl_stream(raw,model,'markers',markers, 'offset',3.5*200);