% set up training parameters
chans = {'C2','PO9','TP8','F3','Fp1','AF7','P7','POz','CP4','F6','P8','C4','F5', ...
    'Fz','P3','P4','FC4','C1','P6','O2','Pz','AF4','F4','CP1','F2','Oz','CP6', ...
    'CPz','CP2','Cz','P5','CP3'};
wnds = [0.25 0.3;0.3 0.35;0.35 0.4; 0.4 0.45;0.45 0.5;0.5 0.55;0.55 0.6];
flt = [0.1 15];
mrks = {'S 11',{'S 12' 'S 13'}};

clear mcr mdl stats mcr2 stats2
for k=1:17
    try
        % load training data (merged vanilla & universal) and train an individualized model
        trainA = io_loadset(['/data/common/christian/temp/Data/Error/VP' num2str(k,'%03d') '/Block3-Game-Error-NoBCI.vhdr']);
        trainB = io_loadset(['/data/common/christian/temp/Data/Error/VP' num2str(k,'%03d') '/Block5-Game-BCI-Univ.vhdr']);
        train = set_merge(trainA,trainB);
        
        [mcr{k},mdl{k},stats{k}] = bci_train({'data',train,'func',@para_windowmeans},'epoch',[0 0.8],'events',mrks,'filter',flt,'channels',chans,'wnds',wnds); %#ok<*ASGLU>
        %[mcr{k},mdl{k},stats{k}] = bci_train({'data',train,'func',@para_dal_lf},'window',[0 0.8],'srate',100,'events',mrks,'filter',flt,'channels',chans); %#ok<*ASGLU>
        %[mcr{k},mdl{k},stats{k}] = bci_train({'data',train,'func',@para_dal_lf},'epoch',[0 0.8],'srate',100,'events',mrks,'spectrum',flt,'channels',chans,'learner',{'dal',search(2.^(-5:0.75:10))}); %#ok<*ASGLU>
    
        % load test data and test the model (on the individualized block)
        test = io_loadset(['/data/common/christian/temp/Data/Error/VP' num2str(k,'%03d') '/Block4-Game-BCI-Indiv.vhdr']);
        [pred,mcr2{k},stats2{k},targ] = bci_predict(mdl{k},test);
    
        disp(['subject ' num2str(k) ':']);
        disp(['  training mis-classification rate: ' num2str(mcr{k}*100,3) '%']);
        disp(['  test mis-classification rate: ' num2str(mcr2{k}*100,3) '%']);
        save results_classic
    catch
        env_handleerror(lasterror);
    end
end

%disp(['predicted classes: ',num2str(round(pred{2}*pred{3})')]);  % class probabilities * class values
%disp(['true classes     : ',num2str(round(targ)')]);
