% --- load raw dataset and set up data-specific parameters (here: eventtype->class mapping) ---
raw = io_loadset('data:/christian/Demo/imag.vhdr');
mrks = {'S  1','S  2'};   % these are our class-indicating stimulus markers

% --- train a model and obtain a default (cross-validated) performance estimate (here: mis-classification rate) as well as additional statistics ---
%[mcr,mdl,stats] = bci_train({'data',raw,'func',@para_csp},'events',mrks,'srate',[]);
[mcr,mdl,stats] = bci_train({'data',raw,'func',@para_speccsp},'events',mrks,'srate',[]);

% some other flavors
%[mcr,mdl,stats] = bci_train({'data',raw,'func',@para_csp},'events',mrks,'patterns',search(1,2,3));
%[mcr,mdl,stats] = bci_train({'data',raw,'func',@para_dal_hf},'events',mrks,'learner',{'dal',search(2.^(-5:0.75:10))});
%[mcr,mdl,stats] = bci_train({'data',raw,'func',@para_dal},'events',mrks,'learner',{'dal',search(2.^(-5:0.75:10))});
%[mcr,mdl,stats] = bci_train({'data',raw,'func',@para_multiband_csp},'events',mrks);
%[mcr,mdl,stats] = bci_train({'data',raw,'func',@para_csp},'events',mrks,'learner',{'logreg' 1 'variant' 'l1'});
%[mcr,mdl,stats] = bci_train({'data',raw,'func',@para_csp},'events',mrks,'learner',{'dal' 1 'regularizer' 'l1'});
%[mcr,mdl,stats] = bci_train({'data',raw,'func',@para_csp},'events',mrks,'learner',{'logreg' search(2.^(-6:1:10)) 'variant' 'l1'});
%[mcr,mdl,stats] = bci_train({'data',raw,'func',@para_csp},'events',mrks,'window',{search(0:0.5:2) search(2.1:0.5:4.1)});
%[mcr,mdl,stats] = bci_train({'data',raw,'func',@para_csp,'eval_scheme',{'chron',20,5}},'events',mrks,'window',[-0.5 2.5]);
%[mcr,mdl,stats] = bci_train({'data',raw,'func',@para_csp},'events',mrks,'learner',{'svmlinear'});
%[mcr,mdl,stats] = bci_train({'data',raw,'func',@para_csp},'events',mrks,'learner',{'svmlinear' 1 'variant','matlab'});
%[mcr,mdl,stats] = bci_train({'data',raw,'func',@para_bandpower},'events',mrks)
% [mcr,mdl,stats] = bci_train({'data',raw,'func',@para_dal}, 'ica',{'amica','max_iter',256,'transform',1}, 'fourier','amplitude', 'srate',180, 'events',mrks, 'regions',{{'freq',[0 1000]}}, 'learner',{'logreg',0.1,'variant','l1'});
% [mcr,mdl,stats] = bci_train({'data',raw,'func',@para_dal}, 'ica',{'amica','max_iter',256,'transform',1}, 'fourier','amplitude', 'srate',180, 'events',mrks, 'regions',{{'freq',[0 1000]}}, 'learner',{'dal', 0.1, 'regularizer','l1'});
% [mcr,mdl,stats] = bci_train({'data',raw,'func',@para_dal}, 'ica',{'amica','max_iter',256,'transform',1}, 'fourier','amplitude', 'srate',180, 'events',mrks, 'regions',{{'freq',[0 1000]}}, 'learner',{'dal', 0.1, 'regularizer','glr'});
% [mcr,mdl,stats] = bci_train({'data',raw,'func',@para_dal}, 'ica',{'amica','max_iter',256,'transform',1}, 'fourier','amplitude', 'srate',180, 'events',mrks, 'regions',{{'freq',[0 1000]}}, 'learner',{'rvm','kernel','rbf','gamma',search(2.^(-16:2:4))});

  disp(['training mis-classification rate: ' num2str(mcr*100,3) '%']);


% --- apply the model to the (here: same) raw dataset (pretending that this were some valid test session) ---
[pred,mcr2,stats2,targ] = bci_predict(mdl,raw);

  disp(['predicted classes: ',num2str(round(pred{2}*pred{3})')]);  % class probabilities * class values
  disp(['true classes     : ',num2str(round(targ)')]);

% --- for demo purposes, stream the raw dataset through the online system (predicting 3.5 seconds after each marker) ---
[opred,olat] = onl_stream(raw, mdl, 'markers',mrks, 'offset',3.5*1000);

   disp(['online prediction; ',num2str(round(opred{2}*opred{3})')]);
   
   