function [mu,sig] = calc_eeg_distribution(eeg,windowlen)
if ~exist('windowlen','var') windowlen = 1; end
windowlen = windowlen*eeg.srate;

[C,S] = size(eeg.data);
% create epochs
X = reshape(eeg.data(:,1:S-mod(S,windowlen)),C,windowlen,[]);
% compute the windowed power distribution
s = squeeze(std(X,0,2)); s = s(:);

% compute median, reflect data around median
med = median(s);
surrogate = [s(s<med); 2*med-s(s<med)];
% fit a gaussian
mu = mean(surrogate);
sig = std(surrogate);

