[r,eeg] = process_concerto_bci3('paradigm','multimodellogregl1-hard_mod_mp','comparison',{3,4})

% get event index list
evtmap = struct('dummy',0,'A_h1',1,'A_h2',1,'B_h1',2,'B_h2',2,'C_h1',3,'C_h2',3,'F_h1',4,'F_h2',4,'H_h1',5,'H_h2',5);
%tmp = exp_eval(eeg{2});
evts = {tmp.event.type};
for ev=1:length(evts)
    evi(ev) = evtmap.(evts{ev});
end

% build confusion matrix...
mat = {};
for s=1:30    
    if s == 1
        p = argmax(r.preds{2}');
    else
        p = argmax(filter(ones(1,s)/s,1,r.preds{2})');
    end
    mat{s} = zeros(5,5);
    for t=1:5
        preds = p(evi(2:end)==t);
        for x=preds
            mat{s}(t,x) = mat{s}(t,x)+1;
        end
    end
    acc(s) = sum(diag(mat{s}))/sum(sum(mat{s}));
end

figure;
plot((1:length(acc))*0.5,acc,'Color','black');
xlabel('aggregation window length in s');
ylabel('accuracy')
title('aggregated classification accuracy over different window lengths');
save2pdf('concerto_final_accuracies.eps',gcf);

% confusion matrix at s
disp('s=10')
s=10;
mat{s}/sum(sum(mat{s}))*100

disp('s=1')
s=1
mat{s}/sum(sum(mat{s}))*100