function result = concerto_load_raw(session)
if ~exp_begindef('filter') return; end

session_files = {'data:/concerto/tim-session1/tim-session1-repaired-properchans.set', ... % dataset for each session
     'data:/concerto/tim-session2/tim-session2-repaired-properchans.set', ...
     'data:/concerto/tim-session3/tim-session3.bdf',...
     'data:/concerto/tim-session4/tim-session4.bdf'};

iv = {'A','B','C','D','E','F','G','H'};  % names of the individual intervals
margin = 5;  % margin between events in first and second half of each interval in seconds
mrate = 2;   % markers per second
srate = 200; % sampling rate


% load
raw = exp_eval(flt_resample(io_loadset(session_files{session}),[],srate));
bpress = find(strcmp('20',{raw.event.type}));
% select the appropriate button press events that delimit the respective intervals (these are hard-coded since our other control signals are lost)
if session == 1
    bpress = bpress([1 2; 3 4; 5 6; 7 8; 9 10; 11 12; 13 14; 15 16]);
else
    bpress = bpress([1 2; 3 4; 5 6; 7 8; 9 10; 11 11; 12 13; 14 15]);
end

% add markers for each interval
result = raw;
for i=1:size(bpress,1)
    % time range of the interval
    range = [raw.event(bpress(i,:)).latency]/raw.srate;
    if range(1) ~= range(2)    
        % insert first-half events
        result = exp_eval(set_inject_events(result,'event',[iv{i} '_h1'], 'segment',{range(1), mean(range)-margin/2}, 'count',mrate, 'counting','persecond', 'placement','equidistant'));
        % insert second-half events
        result = exp_eval(set_inject_events(result,'event',[iv{i} '_h2'], 'segment',{mean(range)+margin/2 range(2)}, 'count',mrate, 'counting','persecond', 'placement','equidistant'));
    end
end

exp_enddef('add_online',@rawdata);