function [err,cla,pre] = do_alpha_traingame(varargin)
opts = hlp_varargin2struct(varargin, ...
        'filename', 'data:/Projekte/AlphaResearch/VP006/Alpha-Kalib', ...
        'jitter_startm', 3, ...     % margin from the beginning of the condition
        'jitter_endm', 3, ...       % margin from the end of the condition
        'jitter_count', 20 ...      % number of random jitters inside the margins
       );

% load
raw = io_quickload(opts.filename);

% define jittered training sections
raw = set_inject_jitters(raw,{'S  1' opts.jitter_startm -opts.jitter_endm 'S  2'}, {opts.jitter_count, {'S  5'}, 'random', 'total'});
raw = set_inject_jitters(raw,{'S  4' opts.jitter_startm -opts.jitter_endm 'S  8'}, {opts.jitter_count, {'S  6'}, 'random', 'total'});

% preprocess them...
pre = bci_preproc(raw,@para_speccsp_train, 'window', [0 5], 'filter', {'fft-gausswnd', [7 30]}, 'events', {'S  5' 'S  6'}); clear raw

% train
disp('training...');
[err,cla] = bci_train(@para_csp_train, pre, {'chron' 10 5}, 1, 1);