% load
raw = io_quickload('data:/christian/Demo/imag');

% optional: preprocess & visualize epochs
% tmp = bci_preproc(raw,@para_speccsp_train,'window',[0 5],'events',{'S  1' 'S  2'},'filter',{'fft-nownd',[5 40]},'channels',1:32,'laplace','full-lap');
% vis_hyperspectrum(tmp);

% specify custom preprocessing (derived from CSP defaults) for later evaluation
epo = bci_preproc(raw,@para_csp_train, 'window',[0 3.5], 'filter',{'fft-gausswnd', [7 30]}, 'events',{'S  1' 'S  2'}, 'channels',1:32, 'srate',[]);
% train & evaluate CSP-based model on preprocessed data using default parameters
[err,det] = bci_train({'data',epo,'func',@para_csp_train})

% apply the online-ready model in a pseudo-online fashion to raw data
[pred,lats] = ext_stream(raw, det, 'sampling_rate',3, 'show_progress',1, 'percent',10);