function [err,claOnl] = do_midas_train(subj, windowsetup, doinspect)

% TODO:
% -500 hz

if ~exist('doinspect') || isempty(doinspect) doinspect =0; end
if ~exist('windowsetup') || isempty(windowsetup) windowsetup='shortgauss'; end


% load the data
if ischar(subj)
    raw = io_quickload(subj);
else    
end

if (doinspect)
    % do a visualization (5 = rotate/go)
    x = bci_preproc(raw,@para_speccsp_train,'window',[0 5],'events',{{'S  5'} {'S 13' 'S 14' 'S 15'}},'filter',{'fft-nownd',[5 40]},'channels',1:34,'laplace','full-lap');
    figure;vis_spectrogram(x,{ 'FCz' 'FCz' 'FC4';'C3' 'Cz' 'C4';'CP3' 'CPz' 'CP4'},'local');

    % do a crossvalidation
    yw = bci_preproc(raw,@para_speccsp_train,'laplace','no-lap','window',[0 2], 'filter', {'fft-gausswnd', [7 30]}, 'events', {{'S  5'} {'S 13' 'S 14' 'S 15'}}, 'channels', 1:34);
    [err,cla] = bci_train(@para_speccsp_train,yw,10,1,3)
    figure;vis_patterns(cla);
    
else
    % create an online classifier
    if strcmp(windowsetup,'shortgauss')
        yo = bci_preproc(raw,@para_speccsp_train,'laplace','no-lap','window',[0.25 1.25], 'filter', 'none', 'events', {{'S 13' 'S 14' 'S 15'} {'S  5'}}, 'channels', 1:34, 'srate', 500);
        [err,claOnl] = bci_train(@para_speccsp_train,yo,10,1,3,[],{{'fft-gausswnd' [7 30]}})
    end

    if strcmp(windowsetup,'medgauss')
        yo = bci_preproc(raw,@para_speccsp_train,'laplace','no-lap','window',[0.25 1.75], 'filter', 'none', 'events', {{'S 13' 'S 14' 'S 15'} {'S  5'}}, 'channels', 1:34, 'srate', 500);
        [err,claOnl] = bci_train(@para_csp_train,yo,10,1,3,[],{{'fft-gausswnd' [7 30]}})
    end

    if strcmp(windowsetup,'longgauss')
        yo = bci_preproc(raw,@para_speccsp_train,'laplace','no-lap','window',[0.25 2.25], 'filter', 'none', 'events', {{'S 13' 'S 14' 'S 15'} {'S  5'}}, 'channels', 1:34, 'srate', 500);
        [err,claOnl] = bci_train(@para_speccsp_train,yo,10,1,3,[],{{'fft-gausswnd' [7 30]}})
    end
    
    if strcmp(windowsetup,'shortrect')
         yo = bci_preproc(raw,@para_speccsp_train,'laplace','no-lap','window',[0.25 1.25], 'filter', 'none', 'events', {{'S 13' 'S 14' 'S 15'} {'S  5'}}, 'channels', 1:34, 'srate', 500);
         % yo = bci_preproc(raw,@para_speccsp_train,'laplace','no-lap','window',[1.4150    4.3150], 'filter', 'none', 'events', {{'S 13' 'S 14' 'S 15'} {'S  5'}}, 'channels', 1:34, 'srate', 500);
        [err,claOnl] = bci_train(@para_speccsp_train,yo,10,1,3,[],{{'fft-nownd' [7 30]}})
    end

    if strcmp(windowsetup,'medrect')
        yo = bci_preproc(raw,@para_speccsp_train,'laplace','no-lap','window',[0.25 1.75], 'filter', 'none', 'events', {{'S 13' 'S 14' 'S 15'} {'S  5'}}, 'channels', 1:34, 'srate', 500);
        [err,claOnl] = bci_train(@para_speccsp_train,yo,10,1,3,[],{{'fft-nownd' [7 30]}})
    end

    if strcmp(windowsetup,'longrect')
        yo = bci_preproc(raw,@para_speccsp_train,'laplace','no-lap','window',[0.25 2.25], 'filter', 'none', 'events', {{'S 13' 'S 14' 'S 15'} {'S  5'}}, 'channels', 1:34, 'srate', 500);
        [err,claOnl] = bci_train(@para_speccsp_train,yo,10,1,3,[],{{'fft-nownd' [7 30]}})
    end
    save classifiers_midas claOnl
    
end
%keyboard
% save it
