function err = do_train_day6_single(subject)
env_cachemode('bypass');

% default parameters
chansel = {'C2','PO9','TP8','F3','Fp1','AF7','P7','POz','CP4','F6','P8','C4','F5', ...
           'Fz','P3','P4','FC4','C1','P6','O2','Pz','AF4','F4','CP1','F2','Oz','CP6', ...
           'CPz','CP2','Cz','P5','CP3'};

% chansel = { 'FC5', 'O1', 'FC3', 'C3', 'P2', 'POz', 'P7', 'F6', 'Fp1', 'C2', 'P8', 'O2', 'FC1', 'F3', ...
%             'CP4', 'P3', 'Fz', 'C4', 'P4', 'CP1', 'AF4', 'FC4', 'C1', 'Pz', 'Oz', 'P6', 'CPz', 'F2', ...
%             'CP6', 'CP2', 'Cz', 'CP3'};
wnds = [0.25 0.3;0.3 0.35;0.35 0.4; 0.4 0.45;0.45 0.5;0.5 0.55;0.55 0.6];
srate = 500;
classifier = hlp_search('lda-full',35);
classifier = {'lda'};


load sabine_components3
% restrict to our channel subset...
component_unmix = component_unmix(:,set_chanid(channels, chansel));
        

% load, preprocess, train
raw = io_quickload(['data:/Projekte/Nature-Error/Datasets/Day6/' utl_vpstring(subject) '/Teil2']);
pre = bci_preproc(raw,@para_simple_train, 'srate', srate, 'laplace','no-lap', 'events',{{'S 11' 'S 17' 'S 18' 'S 27' 'S 28' 'S 29' 'S 30'},{'S 12','S 13'}}, 'window',[0 0.8], 'filter','none', 'channels',chansel);
% project the dataset according to the components
pro = flt_project(pre,component_unmix,utl_strins(1:size(component_unmix,1)));
% generate a classifier which takes the original channels
[err,cla,st,stat] = bci_train(@para_simple_train,pre,0,10,[],{wnds},{'lda'},{{'fft-nownd', [0.1 15]}});
% train a classifier on the components
[err,cla_cmp,st,stat] = bci_train(@para_simple_train,pro,5,10,[],{wnds},classifier,{{'fft-nownd', [0.1 15]}});
% NOW COMES THE MATH!
compwgts = reshape(cla_cmp.model.model.w,[length(cla_cmp.chanlocs),size(wnds,1)])';
compwgts = (compwgts*component_unmix)';
cla.model.model.w = compwgts(:)';
cla.model.model.b = cla_cmp.model.model.b;

% save to disk
cla1 = cla
save classifiers_error cla1
S = date; save(['classifiers_error1-subject_' num2str(subject) ' - ' num2str(S)], 'cla1');