function filepaths = find_eeg_datasets(directory, pattern, filepaths, pathsep)
% recursive function that finds all eeg datasets in 'directory' and all its subdirectories with a history that matches
% some pattern.
% In:
%   directory:  The directory to be searched for eeg datasets
%   pattern:    The pattern that the histories of datasets have to match
%   filepaths:  Filepaths of eeg datasets that have already been found
% Out:
%   same as above

topfiles = dir(directory);
%topfiles = explode(genpath(directory),':');
%topfiles = topfiles(2:end);
for it = {topfiles.name}
    item = char(it);
    whole_path = implode({directory, item}, pathsep);
    %whole_path = item;
    item_split = explode(char(item), '.');
   if(isdir(whole_path) && ~strcmp(item_split(end), '') && ~strcmp(item_split(end), '.'))
       filepaths = [filepaths find_eeg_datasets(whole_path, pattern, filepaths, pathsep)];
       %sprintf(['is dir: ', whole_path])
   elseif strcmp(char(item_split(end)), 'set')
       try
           load_result = pop_loadset(item, directory, 'info'); 
           filepaths = [filepaths whole_path ':'];
       catch error
           sprintf([whole_path, ' cannot be loaded by pop_loadset; ', error])
       end
   end
end
