cd /data/projects/christian/bcilab-0.9/; startup
GPUstart
%% load and clean eeg data
%eeg = exp_eval(flt_resample(flt_selchans(io_loadset('/data/projects/christian/demodata/imagined_movements/imag.vhdr'),1:32), [], 500));
eeg = exp_eval(flt_resample(pop_loadset('/data/projects/laura/flanker_101.set'), [], 250));

% high pass and remove bad channels
% hp_eeg = exp_eval(flt_fir(eeg, [], [5, 100], 'hp'))
% eeg = exp_eval(flt_clean_channels(hp_eeg));

% the above two lines perform a milder cleaning than this
eeg = flt_clean(eeg, 'cleaning_level', 'hardcore');
%% calculate spectrograms for each channel in dataset for frequencies specified in bands
bands = [3 10 75 110 150]; B = length(bands); Wl = eeg.srate; % 1 second wave length
overlap = floor(.75*Wl);
nSamples = length(Wl:(Wl-overlap):size(eeg.data,2)); % the number of columns in spectrogram
spectrograms = zeros(eeg.nbchan, nSamples, B); % initialize the 3D matrix that will contain
% spectrograms for each channel (a row per channel) and the frequencies specified in bands

% calculate spectrograms at specified frequencies
for i = 1:eeg.nbchan
    
    spect = spectrogram(double(eeg.data(i,:)),Wl,overlap,bands,eeg.srate); % actually 
    % power of spectrogram since we're taking absolute value
    for j = 1:B
        spectrograms(i, :, j) = spect(j, :);
    end
    
end
%% map components across frequencies onto one dimension
% run an ICA
icaresult = exp_eval(flt_ica(eeg,[],'fastica','cleaning_level','off', 'approach','symm', 'g','tanh', 'epsilon',0.00001, 'gpu',1));%, 'max_iter',100,'qsub','on','numprocs',24));
W = icaresult.icaweights * icaresult.icasphere; % the actual weights that should be used to go from data to ic domain
onescol = ones(size(W, 1),1); W = single(W .* (onescol*sqrt(1./sum(W.*W)))); % normalize W

% get the ICs in spectrogram space
ic_spectrograms = zeros(size(W, 1), size(spectrograms, 2)); % initialize
    for j = 1:B
        ic_spectrograms(:,:,j) = abs(W * spectrograms(:,:,j)); % fill in j'th frequency
    end
freq_weights = ones(1, B)./bands; % frequency weights
%freq_weights(2) = -freq_weights(2);
skip = Wl-overlap;


spectrumXAxis = (Wl/2 + 1+skip*(0:size(ic_spectrograms, 2)-1))/eeg.srate;

icaresult.icaact = W*icaresult.data;
ics_across_freqs = zeros(size(icaresult.icawinv, 1), size(ic_spectrograms, 2));
figure()
for i = 1:9
    subplot(3,3,i)
    chosen_ic=i;
    chosen_ic_spectrogram = zeros(B, size(ic_spectrograms, 2));
    for j = 1:B
        chosen_ic_spectrogram(j,:) = ic_spectrograms(chosen_ic,:,j); % spectrograms
    % for different frequenices lie in the rows
    end
    
    % for a chosen IC, weigh across frequencies
    chosen_ic_across_freqs = freq_weights * chosen_ic_spectrogram; 
    ics_across_freqs(chosen_ic, :) = chosen_ic_across_freqs;
    % weighted average of spectrum of IC over frequencies, over time
    plot(spectrumXAxis,chosen_ic_across_freqs)
    hold on
    % activation of the IC over time
    plot((1:eeg.pnts)/eeg.srate,icaresult.icaact(chosen_ic,:),'r')
    title(['IC: ', num2str(chosen_ic)])

    hold off
end

%% plot different frequencies separately
figure()
k = 1;
for i = 1:4
    chosen_ic=i;
    chosen_ic_spectrogram = zeros(B, size(ic_spectrograms, 2));
    for j = 1:B
        subplot(4, 5, k)
        plot(spectrumXAxis, ic_spectrograms(chosen_ic,:,j))
        hold on
        plot((1:eeg.pnts)/eeg.srate,15*icaresult.icaact(chosen_ic,:)/bands(j),'r')
        title(['Frequency: ', num2str(bands(j))])
        hold off
        k = k+1;
    end
end
%% identify artifacts automatically using IC's in spectrum space
% identify time points where the spectrogram power is larger than the 95'th percentile
badInds = find(chosen_ic_across_freqs > quantile(chosen_ic_across_freqs, .95));

bads_time_domain = (badInds-1)*skip+1; % bad indices in time domain, middles of the bad intervals i suppose
bads = [];
for i=bads_time_domain
    bads = [bads max(0, i-floor(skip/2)):min(size(icdata, 2), i+floor(skip/2))];
end
%% remove the identified artifacts

% in the ic activity
icdata = icaresult.icaact;
icdata(chosen_ic, bads) = zeros(1, length(bads));
artif_cleaned_data = icaresult.icasphere^(-1)*icaresult.icawinv*icdata;
eeg = artif_cleaned_data;

% in the spectrograms
spectrograms = 


%% other stuff, experimenting

help xcorr

thing = ics_across_freqs(5, :);
figure()
plot(thing)
figure()
hist(thing)

xcorr(thing-mean(thing), 10)


figure()
hist(ics_across_freqs(7, :))

size(icaresult.icaact)
thing1 = icaresult.icaact(1,:);
thing5 = icaresult.icaact(5,:);
lags = 40;

cors1 = xcorr(thing1-mean(thing1), lags, 'coeff');
cors5 = xcorr(thing5-mean(thing5), lags, 'coeff');
figure()
plot(cors1((end/2):end), 'r')
hold on
plot(cors5((end/2):end), 'b')
hold off
icaresult
sum(abs(icaresult.icawinv(1:9, 1:9)))

figure()
plot(kurtosis(icaresult.icaact'))