    EXAMPLE 1: Display the PSD of each segment of a quadratic chirp.
      t=(0:0.001:2);                    % 2 secs @ 1kHz sample rate
      y=chirp(t,100,1,200,'q');       % Start @ 100Hz, cross 200Hz at t=1sec 
      
      
      t=(0:0.001:2)*10;                    % 2 secs @ 1kHz sample rate
      z=chirp(t,100,1,200,'q');       % Start @ 100Hz, cross 200Hz at t=1sec 
      
      %%%%%%%%%%%%%%%%%%
      a = y+z; b = y-z;
      signal = [a; b];
      
      [icasig A W] = fastica(signal, 'sampleWeight', ones(1, length(signal)) )
      
      norm(abs(signal) - abs(W*icasig), 'fro') % >>
      norm(abs(signal) - abs(A*icasig), 'fro')
      
      
      subplot(2,2,1)
      plot(icasig(:,1))
      title('icasig 1')
      subplot(2,2,2)
      plot(-icasig(:,2))
      title('icasig 2')
    
      subplot(2,2,3)
      plot(signal(:,1))
      title('signal 1')
      subplot(2,2,4)
      plot(signal(:,2))
      title('signal 2')
      
      % from fastica comments:
      % [icasig, A, W] = FASTICA (mixedsig); outputs the estimated separating
% matrix W and the corresponding mixing matrix A.
% my thoughts:
% so the mixing matrix A is the matrix which mixes the independent
% components to create the observed signal and W then unmixes (or
% separates) that signal to obtain the independent components

% So, now we have the matrix W which takes us from the observed signal to
% the independent components. We now wish to view the spectrogram of the
% signal in the IC-domain
Wl = 20;
bands = [50 100];
tmp = spectrogram(signal(1,:),Wl,Wl-P,bands,srate);
[tmp2 , ~, ~] = spectrogram(signal(1,:),Wl,Wl-P,bands,srate);

size(tmp)
size(tmp2)

norm(tmp - tmp2, 'fro')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% make sure that spectrum(W*signal) = W*spectrum(signal).

ics_rec = W*signal; % reconstruct independent components
temp1a = spectrogram(ics_rec(1,:),Wl,Wl-P,bands,srate); % find spectrum of independent components
temp1b = spectrogram(ics_rec(2,:),Wl,Wl-P,bands,srate);
temp1 = [temp1a(1,:); temp1b(1,:)]; % the 50 bands for each of the two ic's

signalspeca = spectrogram(signal(1,:),Wl,Wl-P,bands,srate); % find spectrum of signal
signalspecb = spectrogram(signal(2,:),Wl,Wl-P,bands,srate); % find spectrum of signal
signalspec = [signalspeca(1,:); signalspecb(1,:)];
temp2 = W * signalspec; % move spectrum to independent component domain

norm(abs(temp2)-abs(temp1), 'fro')
% yes, it really does seem to be the case when done correctly
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% find out if it's possible to calculate the spectrum for just one
% frequency at a time
band = 50 ; % corresponds to the first band used above
band50ic1 = temp1a(1,:); % as found above




norm(W*abs(tmp) - abs(spectrogram(signalrec(1,:),Wl,Wl-P,bands,srate)), 'fro')

% sum remains at zero, so it does really seem that the spectrogram is
% linear
sum = 0;
for i = 1:100
    hej = randn(100, 1);

    sum = sum + norm(spectrogram(2*hej)-2*spectrogram(hej), 'fro')
end


sum = 0;
for i = 1:100
    hej = randn(100, 1);

    sum = sum + norm(spectrogram(2*hej,Wl,Wl-P)-2*spectrogram(hej,Wl,Wl-P), 'fro')
end


    

%%%%%%%%%%%%%%%%%%%%%%%%
      
      fasticag
     
      
      figure()
      subplot(2,1,1)
      plot(y)
      
      subplot(2,1,2)
      spectrogram(y,128,120,128,1E3); % Display the spectrogram
      title('Quadratic Chirp: start at 100Hz and cross 200Hz at t=1sec');
      spec = spectrogram(zeropadded,W,W-P,bands,srate)
      
      % 'bands'     = [freq,freq,freq,...] or {bandname,freq,freq,bandname...} list of 
%               indicator frequencies in which spectral properties of the signal
%               will be estimated; frequencies may be given as string (e.g. 'alpha','beta','line')
%               (default -> {3 75 110 160 200})
% 'importance'= [value, value, value, ...] vector of importances / weights, per
%               each indicator frequency; must have the same length as bands
%               (default -> [1 1 1 1 1])
      


     
     data = y;
     windowlen = 50; srate = 1E2;
     
     bands = {3 75 110 160 200}; importance = [1 1 1 1];
     bands = [3 75 110 160]; % 3, 150, 200, and 250 would be good choices for artifact identification (eye blinks and muscle artifacts)
     c=1; W = windowlen; S = ceil(W/2);
     P = ceil(srate*0.1);           % we compute the spectrum every P samples
     [C,T] = size(data);
     

     
     zeropadded = double([2*data(c,1) - data(c,(S+1):-1:2), data(c,:), 2*data(c,T) - data(c,(T-1):-1:T-S)]);
     bsxfun(@times,importance',hlp_microcache('tcache',@spectrogram,zeropadded,W,W-P,bands,srate))
     
     tmp = bsxfun(@times,importance',spectrogram(zeropadded,W,W-P,bands,srate));
     
     spec = spectrogram(zeropadded,W,W-P,bands,srate)
     
     figure()
     plot(abs(tmp'))
     
     
     size(tmp)
     
     