function [res,eeg] = process_concerto_bci2(varargin)
opts = hlp_varargin2struct(varargin,'paradigm','ultrawidecsp','comparison',{3,4},'online',1);
global r results; results = [];
global bcilab;

% todo:
% - we have too much stray HF activation
%   -> need to run the better likelihood computation...
%   -> try with a window function (i.e. select) before the fourier transform
%
% - we need more performance
%   -> use the pure logistic regression
%   -> weight classifiers by test-set likelihood
%   -> maybe scale the logreg baseline results(s) by smooth gaussian-derived probabilities
%   -> maybe standardzie the data in a very long window??? (e.g. 5 minutes)
%      - but only the component actication!!
%
% - what kills our performance unnecessarily?
%   - possibly outliers:
%     -> see what code of fastmcd actually *runs*, see if we can combine that with robust & weighted covs
%   - possibly improper distributions:
%     -> can the RVM or any other fully probabilistic (local) classifier help?
%   - our reweighting can certainly be better:
%     -> finally get the LLt to work and try to weight classifiers by the rel. probability of their models!!
%     -> make the classifiers so good that we don't need to renormalize per model
% 

% chance level: 80% error

% valid results tracker:
% -> multimodellogreg-hard, 3vs4, 45% ERRRORORRR

% results tracker:
% -> fourierdal_clean_l1_mm on 3+5+6vs4, 35% error
% -> ultrawidespeccsplr_clean_mm on 3+5+6vs4, 39% error
% -> fourierdal_clean_mm on 3+5+6vs4, 41% error
% -> speccsplr_clean_mm on 3+6vs4, 41% error
% -> ultrawidespeccsplr_clean_mm on 3+6vs4, 45% error
% -> fourierdal_clean_(l1)_brainica on 3+6vs4, 59% error
% -> fourierdal_clean_brainica on 3vs4, 61% error
% -> ultrawidespeccsplr_clean_brainica on 3+6vs4, 62% error
% -> fourierdal_clean_brainica on 3+5+6vs4, 63% error (looks quite nice!)
% -> fourierdal_clean_l1_brainica on 3+5+6vs4, 63% error (looks quite nice!)

% todo: 
% - test with flt_standardize (in a long window)?
% - test whether session 5 is correctly parsed into conditions (button glitch!)
% - get the regular (multi-band) DAL to work on this data, test it...
%   - get the regular DAL to work WELL on motor imagery first
% - obtain a dataset that is FAR better than what we have now:
%    - use hardcore successive rejection of ICA artifacts
%      - learn a regression model on arnos data???? (but that's toooo little!)
% 


% good & clean decomposition A: tim-session3-strongreject-1model.set (AMICA)
% brain comps: 1 2 3 4 5 6 7 8 (8)

% interesting decomposition: tim-session3-test.set (BrainICA)
% brain comps: 4 5 8 9 12 19 22 23 24 (9)


% % compute model on session 3,5,6, test on session 4
% r = process_concerto_bci2('paradigm','fourierdal_clean_l1_brainica','comparison',{3,5,6,4});
if 0
    % multimodel + weighted l1-logreg!
    allweights = [];
    for m=1:length(r.traincla.classifiers)
        W = reshape(sum(abs(r.traincla.classifiers{m}.model.w(:,1:end-1))),length(r.traincla.classifiers{m}.lhs),[]);
        figure;imagesc(W,'XData',(0:269)/270*90); xlabel('Frequency in Hz');ylabel('Component #');title(sprintf('Classifier %d',m));
        allweights = [allweights; W(any(W,2),:)];
    end
    figure;imagesc(allweights,'XData',(0:269)/270*90); xlabel('Frequency in Hz');ylabel('Component #');title(sprintf('All classifiers',m));

    
    allweights = [];
    for m=1:length(r.traincla.classifiers)
        W = reshape(sum(abs(r.traincla.classifiers{m}.model.w(:,1:end-1))),length(r.traincla.classifiers{m}.lhs),[]);
        allweights = [allweights; W(any(W,2),:)];
    end
    figure;imagesc(allweights,'XData',(0:269)/270*90); xlabel('Frequency in Hz');ylabel('Component #');title(sprintf('All classifiers',m));
    
    
    % multimodel + gaussian classifiers
    allweights = [];
    for m=1:length(r.traincla.classifiers)
        W = reshape(r.traincla.classifiers{m}.model.weights,length(r.traincla.classifiers{m}.lhs),[]);
        figure;imagesc(W,'XData',(0:269)/270*90); xlabel('Frequency in Hz');ylabel('Component #');title(sprintf('Classifier %d',m));
        allweights = [allweights; W(any(W,2),:)];
    end
    figure;imagesc(allweights,'XData',(0:269)/270*90); xlabel('Frequency in Hz');ylabel('Component #');title(sprintf('All classifiers',m));
    

    % multimodel + gaussian classifiers
    allweights = [];
    for m=1:length(r.traincla.classifiers)
        W = reshape(r.traincla.classifiers{m}.model.feature_weight,length(r.traincla.classifiers{m}.lhs),[]);
        figure;imagesc(W,'XData',(0:269)/270*90); xlabel('Frequency in Hz');ylabel('Component #');title(sprintf('Classifier %d',m));
        allweights = [allweights; W(any(W,2),:)];
    end
    figure;imagesc(allweights,'XData',(0:269)/270*90); xlabel('Frequency in Hz');ylabel('Component #');title(sprintf('All classifiers',m));
    
    
    % fourier dal weights...
    W = {};
    for j=1:5
        for k=j+1:5
            W{end+1} = abs(reshape(full(r.traincla.predictivemodel.model.voted{j,k}.w),[],270));
            figure;imagesc(W{end},'XData',(0:269)/270*90); xlabel('Frequency in Hz');ylabel('Component #');title(sprintf('ICA Fourier DAL model weights: %d vs %d',j,k));
        end
    end
    figure;imagesc(sum(cat(3,W{:}),3),'XData',(0:269)/270*90); xlabel('Frequency in Hz');ylabel('Component #');title(sprintf('ICA Fourier DAL model weights: %d vs %d',j,k));
    

    % % plot selected components
    %eeg = pop_loadset('/data/projects/concerto/tim-session3/tim-session3-test.set');
    %figure;vis_topoarray(eeg.icawinv(:,[4 5 8 9 12 19 22 23 24]),eeg.chanlocs(eeg.icachansind)); drawnow;
end


load clean_unmixing_matrices4

% select paradigm options
allchans = hlp_microcache('test',@readlocs,'yellow-cap.elp'); chansel = setdiff({allchans(1:128).labels},{'B19','B29','D14','A18','D32','A32'});
switch opts.paradigm
    
    case 'multimodelgausslr'
        paradigm = @para_multimodel; options = {'channels',chans_C, 'models','/data/tmp/bcilab_temp/amicaout-4011620802/model.mat', ...
            'spatial_prior',priorchans_C, 'spectral_prior',priortimes_C,'learner',{'gauss','dimensions',400,'normprobs',-1}};
        
    case 'multimodelgaussunscaled'
        paradigm = @para_multimodel; options = {'channels',chans_C, 'models','/data/tmp/bcilab_temp/amicaout-4011620802/model.mat', ...
            'spatial_prior',priorchans_C, 'spectral_prior',priortimes_C,'learner',{'gauss','dimensions',60,'normprobs',0}};
    case 'multimodelgauss'
        paradigm = @para_multimodel; options = {'channels',chans_C, 'models','/data/tmp/bcilab_temp/amicaout-4011620802/model.mat', ...
            'spatial_prior',priorchans_C, 'spectral_prior',priortimes_C,'learner',{'gauss','dimensions',60}};


    % fully interpretable
    case 'multimodellogreg-hard'
        paradigm = @para_multimodel; options = {'channels',chans_C, 'models','/data/tmp/bcilab_temp/amicaout-4011620802/model.mat', ...
            'spatial_prior',priorchans_C, 'spectral_prior',priortimes_C,'learner',{'logreg',0.05,'variant','l1'}};
        
    case 'multimodellogreg-hard-specprior'
        paradigm = @para_multimodel; options = {'channels',chans_C, 'models','/data/tmp/bcilab_temp/amicaout-4011620802/model.mat', ...
            'spatial_prior',priorchans_C, 'spectral_prior',((1+cos((0:269)/269*pi))/2),'learner',{'logreg',0.05,'variant','l1','scaling','center'}};

        
    % scientifically not as clean, also: quite biased! (needs multiple sessions)
    case 'fourierdal_joint_l1'
        paradigm = @para_dal; options = {'fir',{[0.5 2],'hp','minimum-phase'}, 'fourier','amplitude', 'srate',180, 'channels',chans_C, 'project',matrix_C,  'regions',{{'freq',[0 1000]}}, 'learner',{'dal', 0.1, 'regularizer','l1'}};
    
    
    

%     case 'multimodellogreg-veryhard-specprior'
%         paradigm = @para_multimodel; options = {'channels',chans_C, 'models','/data/tmp/bcilab_temp/amicaout-4011620802/model.mat', ...
%             'spatial_prior',priorchans_C, 'spectral_prior',((1+cos((0:269)/269*pi))/2),'learner',{'logreg',0.1,'variant','l1','scaling','center'}};
        
    case 'multimodellogreg'
        paradigm = @para_multimodel; options = {'channels',chans_C, 'models','/data/tmp/bcilab_temp/amicaout-4011620802/model.mat', ...
            'spatial_prior',priorchans_C, 'spectral_prior',priortimes_C,'learner',{'logreg',0.0013,'variant','l1'}};        


%     case 'multimodellogreg-specprior-softer'
%         paradigm = @para_multimodel; options = {'channels',chans_C, 'models','/data/tmp/bcilab_temp/amicaout-4011620802/model.mat', ...
%             'spatial_prior',priorchans_C, 'spectral_prior',((1+cos((0:269)/269*pi))/2),'learner',{'logreg',0.01,'variant','l1','scaling','center'}};        
%     
%     
%     case 'multimodellogreg-specprior'
%         paradigm = @para_multimodel; options = {'channels',chans_C, 'models','/data/tmp/bcilab_temp/amicaout-4011620802/model.mat', ...
%             'spatial_prior',priorchans_C, 'spectral_prior',((1+cos((0:269)/269*pi))/2),'learner',{'logreg',0.05,'variant','l1','scaling','center'}};        
%         
%     case 'multimodellogreg-windowed'
%         paradigm = @para_multimodel; options = {'channels',chans_C, 'models','/data/tmp/bcilab_temp/amicaout-4011620802/model.mat', ...
%             'window','hann', 'spatial_prior',priorchans_C, 'spectral_prior',priortimes_C,'learner',{'logreg',0.1,'variant','l1','scaling','center'}};        
% 
%     case 'multimodellogreg-windowed-specprior'
%         paradigm = @para_multimodel; options = {'channels',chans_C, 'models','/data/tmp/bcilab_temp/amicaout-4011620802/model.mat', ...
%             'window','hann', 'spatial_prior',priorchans_C, 'spectral_prior',1+cos((0:269)/269*pi),'learner',{'logreg',0.050,'variant','l1','scaling','center'}};        
%         
%     case 'multimodellogreg-windowed-broad-specprior'
%         paradigm = @para_multimodel; options = {'channels',chans_C, 'models','/data/tmp/bcilab_temp/amicaout-4011620802/model.mat', ...
%             'epoch',[-2 2], 'window','hann', 'spatial_prior',priorchans_C, 'spectral_prior',1+cos((0:269)/269*pi),'learner',{'logreg',0.05,'variant','l1','scaling','center'}};

        
        
    case 'multimodel2'
        paradigm = @para_multimodel; options = {'channels',chans_C, 'models','/data/tmp/bcilab_temp/amicaout-4011620802/model.mat', ...
            'spatial_prior',priorchans_C, 'spectral_prior',priortimes_C, 'learner',{'gauss','select',750, 'blend',0.25, 'quiet',0, 'pairwisedims',30, 'totaldims', 90}};
    case 'multimodelsmall'
        paradigm = @para_multimodel; options = {'channels',chans_C, 'models','/data/tmp/bcilab_temp/amicaout-4011620802/model.mat', ...
            'spatial_prior',priorchans_C, 'spectral_prior',priortimes_C, 'learner',{'gauss','select',750, 'blend',0.25, 'quiet',0, 'pairwisedims',15, 'totaldims', 30}};
    case 'multimodelbig'
        paradigm = @para_multimodel; options = {'channels',chans_C, 'models','/data/tmp/bcilab_temp/amicaout-4011620802/model.mat', ...
            'spatial_prior',priorchans_C, 'spectral_prior',priortimes_C, 'learner',{'gauss','select',750, 'blend',0.25, 'quiet',0, 'pairwisedims',70, 'totaldims', 240}};

    
    case 'multimodel1'
        paradigm = @para_multimodel; options = {'channels',chans_C, 'models',model_C,  'spatial_prior',priorchans_C, 'spectral_prior',priortimes_C,'featuresel',0.1,'covblend',0.25};
    case 'multimodeltest'
        paradigm = @para_multimodel; options = {'channels',chans_C, 'models','/data/tmp/bcilab_temp/amicaout-4011620802/model.mat',  'spatial_prior',priorchans_C, 'spectral_prior',priortimes_C,'featuresel',750,'covblend',0.25};
        
        
    % one-model clean ICA
    case 'speccsplr_clean'
        flt = @(f) f>4 & f<35;
        paradigm = @para_speccsp; options = {'srate',300, 'channels',chans_A, 'project',matrix_A, 'epoch',[-1 1], 'spectrum',[8 150], 'prior',flt, 'learner',{'logreg',1,'variant','l2'}, opts}; 
    case 'fourierdal_clean'    
        paradigm = @para_dal; options = {'fourier','amplitude', 'srate',180, 'channels',chans_A, 'project',matrix_A,  'regions',{{'freq',[0 1000]}}, 'learner',{'dal', 0.1, 'regularizer','glr'}};
    case 'fourierdal_clean_l1'    
        paradigm = @para_dal; options = {'fourier','amplitude', 'srate',180, 'channels',chans_A, 'project',matrix_A,  'regions',{{'freq',[0 1000]}}, 'learner',{'dal', 0.1, 'regularizer','l1'}};        
        
    % artifact-controlled BrainICA
    case 'speccsplr_clean_brainica'
        flt = @(f) f>4 & f<35;
        paradigm = @para_speccsp; options = {'srate',300, 'channels',chans_B, 'project',matrix_B, 'epoch',[-1 1], 'spectrum',[8 150], 'prior',flt, 'learner',{'logreg',1,'variant','l2'}, opts}; 
    case 'fourierdal_clean_brainica'    
        paradigm = @para_dal; options = {'fourier','amplitude', 'srate',180, 'channels',chans_B, 'project',matrix_B,  'regions',{{'freq',[0 1000]}}, 'learner',{'dal', 0.1, 'regularizer','glr'}};
    case 'fourierdal_clean_l1_brainica'    
        paradigm = @para_dal; options = {'fourier','amplitude', 'srate',180, 'channels',chans_B, 'project',matrix_B,  'regions',{{'freq',[0 1000]}}, 'learner',{'dal', 0.1, 'regularizer','l1'}};        
        
    % clean components from 6-model amica
    case 'fourierdal_clean_l1_mm'
        paradigm = @para_dal; options = {'fourier','amplitude', 'srate',180, 'channels',chans_C, 'project',matrix_C,  'regions',{{'freq',[0 1000]}}, 'learner',{'dal', 0.1, 'regularizer','l1'}};
    case 'fourierdal_clean_l1_mm_reg'
        paradigm = @para_dal; options = {'fourier','amplitude', 'srate',180, 'channels',chans_C, 'project',matrix_C,  'regions',{{'freq',[0 1000]}}, 'learner',{'dal', search(2.^(-6:0.5:10)), 'regularizer','l1'}};
    case 'fourierdal_clean_mm'
        paradigm = @para_dal; options = {'fourier','amplitude', 'srate',180, 'channels',chans_C, 'project',matrix_C,  'regions',{{'freq',[0 1000]}}, 'learner',{'dal', 0.1, 'regularizer','glr'}};        
    case 'ultrawidespeccsplr_clean_mm'
        flt = @(f) f>8 & f<150 & ~(f>55 & f<65);
        paradigm = @para_speccsp; options = {'srate',300, 'channels',chans_C, 'project',matrix_C, 'epoch',[-1 1], 'spectrum',[8 150], 'prior',flt, 'learner',{'logreg',1,'variant','l2'}, opts}; 
    case 'speccsplr_clean_mm'
        flt = @(f) f>4 & f<35;
        paradigm = @para_speccsp; options = {'srate',300, 'channels',chans_C, 'project',matrix_C, 'epoch',[-1 1], 'spectrum',[8 150], 'prior',flt, 'learner',{'logreg',1,'variant','l2'}, opts}; 

    % overcomplete dictionary from all 6 amica models
    case 'fourierdal_clean_l1_oc'
        paradigm = @para_dal; options = {'fourier','amplitude', 'srate',180, 'channels',chans_C, 'reconstruct',dict_C, 'regions',{{'freq',[0 1000]}}, ...
            'learner',{'dal', 0.1, 'regularizer','l1', 'chan_prior',priorchans_C, 'time_prior',priortimes_C}};
    case 'fourierdal_clean_l1_ochp'
        paradigm = @para_dal; options = {'fourier','amplitude', 'srate',180, 'channels',chans_C, 'fir',{[0.5 2],'hp','minimum-phase'},'reconstruct',dict_C, 'regions',{{'freq',[0 1000]}}, ...
            'learner',{'dal', 0.1, 'regularizer','l1', 'chan_prior',priorchans_C, 'time_prior',priortimes_C}};

    % old analyses
    case 'ultrawidespeccsplr_clean'
        flt = @(f) f>8 & f<150 & ~(f>55 & f<65);
        paradigm = @para_speccsp; options = {'srate',300, 'channels',chans_A, 'project',matrix_A, 'epoch',[-1 1], 'spectrum',[8 150], 'prior',flt, 'learner',{'logreg',1,'variant','l2'}, opts};         
    case 'ultrawidespeccsplr_clean_brainica'
        flt = @(f) f>8 & f<150 & ~(f>55 & f<65);
        paradigm = @para_speccsp; options = {'srate',300, 'channels',chans_B, 'project',matrix_B, 'epoch',[-1 1], 'spectrum',[8 150], 'prior',flt, 'learner',{'logreg',1,'variant','l2'}, opts}; 
    case 'ultrawidecsp'
        paradigm = @para_csp; options = {'srate',[], 'channels',1:128, 'epoch',[-1 1], 'spectrum',[8 55; 65 200], opts}; 
    case 'ultrawidespeccsp'
        flt = @(f) f>8 & f<150 & ~(f>55 & f<65);
        paradigm = @para_speccsp; options = {'srate',300, 'channels',1:128, 'epoch',[-1 1], 'spectrum',[8 150], 'prior',flt, opts}; 
    case 'speccsp'
        flt = @(f) f>8 & f<55;
        paradigm = @para_speccsp; options = {'srate',150, 'channels',1:128, 'epoch',[-1 1], 'spectrum',[8 60], 'prior',flt, opts}; 
    case 'speccsplr'
        flt = @(f) f>8 & f<55;
        paradigm = @para_speccsp; options = {'srate',150, 'channels',1:128, 'epoch',[-1 1], 'spectrum',[8 60], 'prior',flt, 'learner',{'logreg',1,'variant','l2'},opts}; 
    case 'ultrawidespeccsplr'
        flt = @(f) f>8 & f<150 & ~(f>55 & f<65);
        paradigm = @para_speccsp; options = {'srate',300, 'channels',1:128, 'epoch',[-1 1], 'spectrum',[8 150], 'prior',flt, 'learner',{'logreg',1,'variant','l2'}, opts}; 
    case 'csplr'
        paradigm = @para_csp; options = {'srate',[], 'channels',1:128, 'epoch',[-1 1], 'spectrum',[7 55], 'learner',{'logreg',1,'variant','l2'}, opts}; 
    case 'dal'
        paradigm = @para_dal_hf; options = {'srate',150, 'channels',1:128, 'epoch',[-1 1], 'spectrum',[7 55],opts}; 
    otherwise
        error('unknown paradigm');
end

% select data and markers
events = {{{'A_h1','A_h2'},{'B_h1','B_h2'},{'C_h1','C_h2'},{'F_h1','F_h2'},{'H_h1','H_h2'}}, {{'A_h1','A_h2'},{'B_h1','B_h2'},{'C_h1','C_h2'},{'F_h1','F_h2'},{'H_h1','H_h2'}}};
eeg = cellfun(@concerto_load_raw_reduced,opts.comparison,'UniformOutput',false);
if length(eeg) > 2
    eeg = {set_merge(eeg{1:end-1}),eeg{end}}; end

% turn on memory & disk cache, turn off unnecessary checks
exp_eval(Set(@memoize,{'memory',0,'disk',1}));
exp_eval(Set(@fingerprint_check,0));
exp_eval(Set(@fingerprint_create,0));

% set cache capacity, depending on machine
if ispc
    bcilab.cache.capacity = 1000000000; 
else
    [ret,name] = system('hostname'); %#ok<ASGLU>
    if strcmp(name,'Dellos') 
        bcilab.cache.capacity = 4000000000; end
    if ~isempty(strfind(name,'compute-'))
        bcilab.cache.capacity = 1000000000; end % was 6gb
end

% train
[r.trainerr,r.traincla,r.trainstats] = bci_train({'func',paradigm,'data',eeg{1},'opt_scheme',[1,10,2],'eval_scheme',0},'events',events{1},options{:});

% test 
[r.preds,r.testerr,r.teststats] = bci_predict(r.traincla,eeg{end});

r

% plot time course
figure('position',[0 0 1600 300]);imagesc(filtfilt(ones(1,10),1,r.preds{2})');
title([opts.paradigm ': tested on ' num2str([opts.comparison{:}])],'Interpreter','none');
ylabel('Predicted Distribution');
xlabel('Session time')
save2pdf('concerto-spec-3vs4.pdf',gcf)

try
allweights = [];
comps = [];
for m=1:length(r.traincla.classifiers)
    W = reshape(sum(abs(r.traincla.classifiers{m}.model.w(:,1:end-1))),length(r.traincla.classifiers{m}.lhs),[]);
    allweights = [allweights; W(any(W,2),:)];
end
figure;imagesc(allweights,'XData',(0:269)/270*90); xlabel('Frequency in Hz');ylabel('Component #');title(sprintf('All classifiers',m));
figure;imagesc(filtfilt_fast(ones(5,1),1,allweights')','XData',(0:269)/270*90); xlabel('Frequency in Hz');ylabel('Component #');title(sprintf('All classifiers; smoothed weights',m));

catch,end


try
        % multimodel + gaussian classifiers
    allweights = [];
    for m=1:length(r.traincla.classifiers)
        W = reshape(r.traincla.classifiers{m}.model.feature_weight,length(r.traincla.classifiers{m}.lhs),[]);
        figure;imagesc(W,'XData',(0:269)/270*90); xlabel('Frequency in Hz');ylabel('Component #');title(sprintf('Classifier %d',m));
        allweights = [allweights; W(any(W,2),:)];
    end
    figure;imagesc(allweights,'XData',(0:269)/270*90); xlabel('Frequency in Hz');ylabel('Component #');title(sprintf('All classifiers',m));
figure;imagesc(filtfilt_fast(ones(5,1),1,allweights')','XData',(0:269)/270*90); xlabel('Frequency in Hz');ylabel('Component #');title(sprintf('All classifiers; smoothed weights',m));
catch,end

% 
% % plot Spec-CSP scalp maps
% figure('position',[0 0 1600 800])
% comps = {[1 2] [1 3] [1 4] [1 5] [2 3] [2 4] [2 5] [3 4] [3 5] [4 5]};
% for c = 1:length(comps)
%     for p = 1:6
%         subplot(6,length(comps),(p-1)*length(comps)+c);
%         topoplot(r.traincla.voting{comps{c}(1),comps{c}(2)}.featuremodel.W(:,p),r.traincla.bcilab.channel_locations); 
%         title(num2str(p));
%         camzoom(1.75);
%     end
% end
% 
% % plot spectral filters
% filtlen = 8;
% figure('position',[0 0 1600 800])
% comps = {[1 2] [1 3] [1 4] [1 5] [2 3] [2 4] [2 5] [3 4] [3 5] [4 5]};
% for c = 1:length(comps)
%     for p = 1:6
%         subplot(6,length(comps),(p-1)*length(comps)+c);
%         m = r.traincla.voting{comps{c}(1),comps{c}(2)}.featuremodel;
%         plot(m.freqs(m.bands),filtfilt(ones(1,filtlen),1,m.alpha(m.bands,p)));
%         %topoplot(r.traincla.voting{comps{c}(1),comps{c}(2)}.featuremodel.W(:,p),r.traincla.bcilab.channel_locations); 
%         title(num2str(p));
%     end
% end

%     % test the online system & display results
%     if opts.online
%         [r.predsom,r.latsom] = onl_stream(eeg{end},r.traincla,'markers',[events{end}{:}],'show_progress',1,'offset',512);
%         figure;imagesc(filtfilt(ones(1,100),1,r.predsom{2}(1:end,:))); title('online');
%         preds = r.predsom;
%     end


% save properly
classifier = r.traincla;
save emo-classifier-new.mat classifier

results = r;
res = r;

% 
% % plot CSP scalp maps
% figure('position',[0 0 1600 800])
% comps = {[1 2] [1 3] [1 4] [1 5] [2 3] [2 4] [2 5] [3 4] [3 5] [4 5]};
% for c = 1:length(comps)
%     for p = 1:6
%         subplot(6,length(comps),(p-1)*length(comps)+c);
%         topoplot(r.traincla.voting{comps{c}(1),comps{c}(2)}.featuremodel(:,p),r.traincla.bcilab.channel_locations); 
%         title(num2str(p));
%         camzoom(1.75);
%     end
% end



% r=process_concerto_bci('comparison',{3,4},'paradigm','speccsplr') -23% error