function set = set_append_simulatordata(eegset,simulatorset);
% set = set_add_car2eeg(eegset,carset,chans);
% add cardata to existing eeg dataset 
%
% In:
%       eegset          :   name of the eeg dataset
%       simulatorset    :   name of the simulatordata (imported by io_simulatordata)
%      
%
% Out:
%       Set             :   continuous eeg & simulator dataset
%
%
%                                                     Sebastian Welke
%                                                     31.07.2008

% find Start mark S100 in eeg dataset
for i = [1:10]
    if strcmp(eegset.event(i).name,'S100')
        start_mark=eegset.event(i).latency;
        id=i;
    end
end

% create new eegset starting with start_mark
tmpeegset.data=eegset.data(1:36,start_mark:length(eegset.data));
eegset.data=tmpeegset.data;

eegset.pnts=length(eegset.data);

% remove latencies
for i=[1:length(eegset.event)]
    eegset.event(1,i).latency = eegset.event(i).latency - start_mark;
end


% compare  and fit length of sets
if length(eegset.data) < length(simulatorset.data)
    end_mark = length(eegset.data);
    simulatorset.data = simulatorset.data(1:6,1:end_mark);
    simulatorset.pnts = end_mark;
else
    end_mark = length(simulatorset.data);
    eegset.data = eegset.data(1:36,1:end_mark);
    eegset.pnts = end_mark;
end

% append data
for i= [eegset.nbchan+1 : eegset.nbchan+6]
    eegset.data(i,:)=simulatorset.data(i-eegset.nbchan,:);
    eegset.chanlocs(i)=simulatorset.chanlocs(i-eegset.nbchan);
end;
eegset.nbchan=eegset.nbchan+6;
set = eegset;

