% compute a spectral subset from the full spectrum, optionally starting from a previous spectral subset (that significantly overlaps with the current one)
% New-Spectral-Subset = subset_spectrum(Full-Spectrum, Trial-Subset, Band-Subset, Previous-Spectral-Subset, Previous-Trials)
% [Chns x Chns x Freqs] = subset_spectrum([Chns x Chns x Smpls x Trials], Trials1, Bands, [Chns x Chns x Frqs], Trials2)
function [S t1] = subset_spectrum(F,t1,b,S,t0)
if isempty(S) || isempty(t0)
    S(:,:,b) = mean(F(:,:,b,t1),4);
else
    [add,rem] = deal(setdiff(t1,t0),setdiff(t0,t1));
    S(:,:,b) = S(:,:,b)*length(t0);
    if isempty(add)
        if ~isempty(rem)
            S(:,:,b) = S(:,:,b) - sum(F(:,:,b,rem),4); end
    else
        if isempty(rem)
            S(:,:,b) = S(:,:,b) + sum(F(:,:,b,add),4);
        else
            S(:,:,b) = S(:,:,b) - sum(F(:,:,b,rem),4) + sum(F(:,:,b,add),4);
        end
    end
    S(:,:,b) = S(:,:,b)/length(t1);
end