function y = test_compress(a)
retain = 0.95;
framelen = 1024;
wname = 'db8';
levels = 5;
frames = floor(size(a.data,2)/framelen);
channels = size(a.data,1);

fprintf('\ncompressing');
code = cell(1,frames);
for f=1:frames
    % get a chunk of data
    X = a.data(:,1 + (f-1)*framelen:f*framelen);
    % pre=scale it
    scale = max(abs(X(:))); X = X/scale;
    % for each channel...
    for c=1:channels
        x = X(c,:);
        % decompose
        T = wpdec(x,levels,wname);
        % threshold
        C = read(T,'data'); AC = C.*C;
        [CS,I] = sort(AC,'descend'); CS=CS/sum(CS);
        C(I(cumsum(CS)>retain)) = 0;
        % quantize
        maxval = max(abs(C));
        C = int8(C*(127/maxval));
        % store
        T = write(T,'data',C);
        code{f}{c} = {T,scale,maxval};
        % reconstruct
%         C = read(T,'data');
%         C = single(C)*(maxval/127);
%         R = wprec(write(T,'data',C))*scale;
%         hold off;plot(x*scale,'r');hold on;plot(R,'g'); drawnow;
%         disp(mean(C==0));
    end
    fprintf('.');
end

encoding = struct('code',{code},'framelen',framelen,'wname',wname,'levels',levels,'retain',retain);
y = a; y.icaact = []; y.data = encoding;