window_len = 0.5;

eeg = b;

[C,S] = size(eeg.data);
window_len = window_len*eeg.srate;
wnd = 0:window_len-1;
offsets = 1:window_len/4:S-window_len;
W = length(offsets);
retained = 1:(C-ceil(C*ignored_quantile));

X = eeg.data;
% find the covariance distribution of the signal...
XC = zeros(C,C,length(offsets));
for o=1:W
    S = X(:,1+floor(offsets(o))+wnd);
    XC(:,:,o) = cov(S');
end
XM = mean(XC,3);
XS = std(XC,0,3);
XX = sort(XC,3);
XQ = XX(:,:,floor(length(offsets)*0.75));

Y = zeros(C,size(eeg.data,2));
for o=1:W
    % get the data window and its principal components (basis for the new signal)
    S = X(:,1+floor(offsets(o))+wnd);
    [V,D] = eig(cov(S'));
    % get the signal and its variance
    signal = V'*S;
    signal_variance = var(signal,[],2);
    % do a masking of the upper 
    mask = signal_variance > diag(V'*XQ*V); mask(1:ceil(length(mask)/2)) = 0;    
    % write the masked signal into Y
    % Y(end:-1:1,1+floor(offsets(o))+wnd) = bsxfun(@times,signal .* repmat(mask,1,length(wnd)), 0.5*hann(length(wnd))');
    % back-project the cleaned signal into Y
    Y(:,1+floor(offsets(o))+wnd) = Y(:,1+floor(offsets(o))+wnd)+bsxfun(@times,(pinv(V') * (signal .* repmat(~mask,1,length(wnd)))),0.5*hann(length(wnd))');
end

neweeg = eeg;
neweeg.data = [X;Y/3];
%neweeg.data = Y;
neweeg.nbchan = size(neweeg.data,1);
