% benchmark fftfilt

ini_state = [0 1];
final_state = [0 1];
max_b = 16;
max_x = 22;

b = randn(2^max_b,1);
x = randn(2^max_x,1);

raw = zeros(max_b,max_x,length(ini_state),length(final_state));
fst = zeros(max_b,max_x,length(ini_state),length(final_state));

for len_b = 2:max_b
    disp(len_b);
    B = b(1:2^len_b);
    [Y,Zi] = filter(B,1,x(1:(2^len_b+1)));
    for inistate = [0 1]
        for finalstate = [0 1]
            
            for len_x = len_b:max_x
                X = x(1:2^len_x);
                % get appropriate initial state for testing
                tic
                if inistate
                    if finalstate
                        [Y1,Zf1] = filter(B,1,X,Zi);
                    else
                        [Y1] = filter(B,1,X,Zi);
                    end
                else
                    if finalstate
                        [Y1,Zf1] = filter(B,1,X);
                    else
                        [Y1] = filter(B,1,X);
                    end
                end
                raw(len_b,len_x,inistate+1,final_state+1) = toc;
                tic
                if inistate
                    if finalstate
                        [Y2,Zf2] = filter_fast(B,1,X,Zi);
                    else
                        [Y2] = filter_fast(B,1,X,Zi);
                    end
                else
                    if finalstate
                        [Y2,Zf2] = filter_fast(B,1,X);
                    else
                        [Y2] = filter_fast(B,1,X);
                    end
                end                
                if mean(abs(Y1-Y2)) > 0.000001
                    keyboard;
                end
                if finalstate
                    if size(Zf1) ~= size(Zf2)
                        keyboard;
                    elseif mean(abs(Zf1-Zf2)) > 0.00001
                        keyboard;
                    end
                end
                fst(len_b,len_x,inistate+1,final_state+1) = toc;
            end
        end
    end
end

% plot results:
i=1;j=1; data = (fst(:,:,i,j) - raw(:,:,i,j))./raw(:,:,i,j); data(data<0) = data(data<0)*10; data(end) = -25; data(isnan(data)) = 25; figure; imagesc(data)